////////////////////////////////////////////////////////////////////////////////
// Mechanical trade system for MetaTrader 5                                   //
// Multifunctional information system for mechanical trading                  //
// Copyright (c) 2005-2011 Interesting                                        //
// Mail: MD-Interesting@Mail.ru                                               //
////////////////////////////////////////////////////////////////////////////////
// Mechanical trade system for trading on market Forex                        //
// Template for creating an expert for the terminal MetaTrader 5              //
// Unit: Forum                                                                //
////////////////////////////////////////////////////////////////////////////////
// Version:      2.0                                                          //
// Version File: 2.0.0.0                                                      //
// File name: Forum.mq5                                                       //
////////////////////////////////////////////////////////////////////////////////
//                                  Property                                  //
////////////////////////////////////////////////////////////////////////////////
#property description "Mechanical trade system for trading on market Forex"
#property description "Version File: 2.0.0.0"
#property copyright   "interesting"
#property link        "Mail: MD-interesting@Mail.ru"
#property version     "2.00"
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//Class CMqlExpert
class CMqlExpert
//Base class of the object "Trade expert"
{
//----------------------------------------------------------------------------//
protected:
//****************************************************************************//
//                    Protected declarations of the class                     //
//****************************************************************************//

//----------------------------------------------------------------------------//
public:
//****************************************************************************//
//                      Public declarations of the class                      //
//****************************************************************************//
//----------------------------------------------------------------------------//
//                     Public characteristics of the class                    //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
//                         Constructor and Destructor                         //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
//                         Public methods of the class                        //
//----------------------------------------------------------------------------//
//Methods of the trade system
virtual bool MarketBuy(string SymbolTitle){return(true);};  //New position buy
virtual bool MarketSell(string SymbolTitle){return(true);}; //New position sell
//----------------------------------------------------------------------------//
//                         Public events of the class                         //
//----------------------------------------------------------------------------//
//Standard events of the trade system
virtual bool OnTick(){return(true);};  //Processing the event NewTick (OnTick)
virtual bool OnTimer(){return(true);}; //Processing the event Timer (OnTimer)
//----------------------------------------------------------------------------//
};
//****************************************************************************//
//Class CMqlForexExpert
class CMqlForexExpert : public CMqlExpert
//Base class of the object "Trade expert for forex"
{
//----------------------------------------------------------------------------//
protected:
//****************************************************************************//
//                    Protected declarations of the class                     //
//****************************************************************************//

//----------------------------------------------------------------------------//
public:
//****************************************************************************//
//                      Public declarations of the class                      //
//****************************************************************************//
//----------------------------------------------------------------------------//
//                     Public characteristics of the class                    //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
//                         Constructor and Destructor                         //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
//                         Public methods of the class                        //
//----------------------------------------------------------------------------//
//Methods of the trade system
virtual bool MarketBuy(string SymbolTitle,double LotSize){return(true);};  //New position buy
virtual bool MarketSell(string SymbolTitle,double LotSize){return(true);}; //New position sell
//----------------------------------------------------------------------------//
//                         Public events of the class                         //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
};
//****************************************************************************//
//Class CMqlMyExpert
class CMqlMyExpert : public CMqlForexExpert
//Base class of the object "Main expert for trading"
{
//----------------------------------------------------------------------------//
protected:
//****************************************************************************//
//                    Protected declarations of the class                     //
//****************************************************************************//

//----------------------------------------------------------------------------//
public:
//****************************************************************************//
//                      Public declarations of the class                      //
//****************************************************************************//
//----------------------------------------------------------------------------//
//                     Public characteristics of the class                    //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
//                         Constructor and Destructor                         //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
//                         Public methods of the class                        //
//----------------------------------------------------------------------------//
//Methods of the trade system (New position buy)
virtual bool MarketBuy(string SymbolTitle,double LotSize);
virtual bool MarketBuy(string SymbolTitle,double LotSize,double TP,double SL);
//Methods of the trade system (New position sell)
virtual bool MarketSell(string SymbolTitle,double LotSize);
virtual bool MarketSell(string SymbolTitle,double LotSize,double TP,double SL);
//----------------------------------------------------------------------------//
//                         Public events of the class                         //
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
};
////////////////////////////////////////////////////////////////////////////////
//             Global variables, used in working the trade system             //
////////////////////////////////////////////////////////////////////////////////
CMqlMyExpert Expert;
////////////////////////////////////////////////////////////////////////////////
//                                Trade expert                                //
////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
//                       Expert initialization function                       //
//****************************************************************************//
int OnInit()
{
//----------------------------------------------------------------------------//
//Work variables
int Result = 0; //Returned importance
//----------------------------------------------------------------------------//
EventSetTimer(30);
//----------------------------------------------------------------------------//
return(Result);
//----------------------------------------------------------------------------//
}
//****************************************************************************//
//                      Expert deinitialization function                      //
//****************************************************************************//
//Procedure OnDeinit
void OnDeinit(const int reason)
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
}
//****************************************************************************//
//                           Expert Ticks function                            //
//****************************************************************************//
//Event OnTick
void OnTick()
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
}
//****************************************************************************//
//                           Expert Timer function                            //
//****************************************************************************//
//Event OnTimer
void OnTimer()
{
//----------------------------------------------------------------------------//
//Work variables
int random;
//----------------------------------------------------------------------------//

random=rand()%2;

  switch(random)
  {
  case 0: Expert.MarketBuy(Symbol(),0.10,1.45,1.43);  break;
  case 1: Expert.MarketSell(Symbol(),0.10,1.43,1.45);  break;
  }
//----------------------------------------------------------------------------//
}
//****************************************************************************//
//                         Expert Book Event function                         //
//****************************************************************************//
//Event OnBookEvent
void OnBookEvent(const string& symbol)
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
}
//****************************************************************************//
//                        Expert Chart Event function                         //
//****************************************************************************//
//Event OnChartEvent
void OnChartEvent(const int id,
                  const long& lparam,
                  const double& dparam,
                  const string& sparam
                  )
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//
//                          Processing user events                            //
//----------------------------------------------------------------------------//
  if(id>CHARTEVENT_CUSTOM)
  //User event is received
  {
  }
//----------------------------------------------------------------------------//  
}
//****************************************************************************//
//                           Expert trade function                            //
//****************************************************************************//
//Event OnTrade
void OnTrade()
{
//----------------------------------------------------------------------------//
//Work variables
//----------------------------------------------------------------------------//

//----------------------------------------------------------------------------//  
}
//****************************************************************************//
//                           Expert tester function                           //
//****************************************************************************//
//Event OnTester
double OnTester()
{
//----------------------------------------------------------------------------//
//Work variables
double Result = 0;
//----------------------------------------------------------------------------//

Result = 0;

ResetLastError();

//Processing

//Checking for presence of the errors
  if(_LastError!=0)
  {
  Result = -1;  
  }
//----------------------------------------------------------------------------//
return(Result);
//----------------------------------------------------------------------------//
}
////////////////////////////////////////////////////////////////////////////////
//                               Implementation                               //
////////////////////////////////////////////////////////////////////////////////
//Event CMqlMyExpert.MarketBuy
bool CMqlMyExpert::MarketBuy(string SymbolTitle,double LotSize)
{
//----------------------------------------------------------------------------//
//Work variables
bool Result = true; //Returned importance
//----------------------------------------------------------------------------//

Result = MarketBuy(SymbolTitle);

  if(Result)
  {
  Print("  ",SymbolTitle," LotSize = ",LotSize);
  }
//----------------------------------------------------------------------------//
return(Result);
//----------------------------------------------------------------------------//
}
//****************************************************************************//
//Event CMqlMyExpert.MarketBuy
bool CMqlMyExpert::MarketBuy(string SymbolTitle,double LotSize,double TP,double SL)
{
//----------------------------------------------------------------------------//
//Work variables
bool Result = true; //Returned importance
//----------------------------------------------------------------------------//

Result = MarketBuy(SymbolTitle,LotSize);

  if(Result)
  {
  Print("    ! "," LotSize = ",LotSize," TP= ",TP," SL= ",SL);
  }
//----------------------------------------------------------------------------//
return(Result);
//----------------------------------------------------------------------------//
}
//****************************************************************************//
//Event CMqlMyExpert.MarketSell
bool CMqlMyExpert::MarketSell(string SymbolTitle,double LotSize)
{
//----------------------------------------------------------------------------//
//Work variables
bool Result = true; //Returned importance
//----------------------------------------------------------------------------//

Result = MarketSell(SymbolTitle);

  if(Result)
  {
  Print("  ",SymbolTitle," LotSize = ",LotSize);
  }
//----------------------------------------------------------------------------//
return(Result);
//----------------------------------------------------------------------------//
}
//****************************************************************************//
//Event CMqlMyExpert.MarketSell
bool CMqlMyExpert::MarketSell(string SymbolTitle,double LotSize,double TP,double SL)
{
//----------------------------------------------------------------------------//
//Work variables
bool Result = true; //Returned importance
//----------------------------------------------------------------------------//

Result = MarketSell(SymbolTitle,LotSize);

  if(Result)
  {
  Print("    ! "," LotSize = ",LotSize," TP= ",TP," SL= ",SL);
  }
//----------------------------------------------------------------------------//
return(Result);
//----------------------------------------------------------------------------//
}
////////////////////////////////////////////////////////////////////////////////